part of insync;

abstract class AbstractCollectionHeaper<V, C extends AbstractCollection<V>> extends Owner {
  C _source;
  C get source => _source;

  AbstractSet<V> _target;
  AbstractSet<V> get target => _target;

  AbstractCollectionHeaper(this._source, {AbstractSet<V> target}) {
    assert(_source != null);
    _target = (target != null) ? target : _source.createEmptySet()..ownBy(this);
    _target.tryAddAll(_source.asList());
  }

  void destroy() {
    _target.tryRemoveAll(_source.asList());
    super.destroy();
  }
}