part of insync;

abstract class AbstractCollectionIndexer<K, V, C extends AbstractCollection<V>>
extends Owner {
  Function _getKey;

  C _source;
  C get source => _source;

  AbstractMap<K, V> _target;
  AbstractMap<K, V> get target => _target;

  AbstractCollectionIndexer(this._source, {AbstractMap<K, V> target, K getKey(V value)}) :
  _getKey = getKey {
    assert(_source != null);
    assert(_getKey != null);
    _target = (target != null) ? target : _source.createEmptyMap()..ownBy(this);
    _target.trySetAll(_index(_source.asList()));
  }

  void destroy() {
    _target.tryRemoveAll(_keys(_source.asList()));
    super.destroy();
  }

  Map<K, V> _index(List<V> values) {
    Map<K, V> index = new Map<K, V>();
    for (int i = 0; i < values.length; ++i) {
      index[_getKey(values[i])] = values[i];
    }
    return index;
  }

  List<K> _keys(List<V> values) {
    return new List.generate(values.length, (int i) => _getKey(values[i]), growable: false);
  }
}