part of insync;

abstract class AbstractCollectionMapper<S, T, SC extends AbstractCollection<S>,
    TC extends AbstractCollection<T>> extends Owner {
  Function _createItem;
  Function _destroyItem;

  SC _source;
  SC get source => _source;

  TC _target;
  TC get target => _target;

  AbstractCollectionMapper(this._source, {TC target, T create(S data),
    void destroy(T item, S data)}) :
      _createItem = create,
      _destroyItem = destroy {
    assert(_source != null);
    assert(_createItem != null);
    _target = (target != null) ? target : _source.createEmpty()..ownBy(this);
  }
}