part of insync;

class AbstractCollectionObserver<V, C extends AbstractCollection<V>> extends Owner {
  Function _addValue;
  Function _removeValue;
  Function _clearValues;
  Function _change;

  C _source;
  C get source => _source;

  AbstractCollectionObserver(this._source, {void add(V value), void remove(V value),
    void clear(List<V> values), void change()}) :
      _addValue = add,
      _removeValue = remove,
      _clearValues = clear,
      _change = change {
    assert(_source != null);
    _add(_source.asList());
  }

  void destroy() {
    _clear(_source.asList());
    super.destroy();
  }

  void _add(List<V> values) {
    if (_addValue == null) {
      return;
    }
    for (int i = 0; i < values.length; ++i) {
      _addValue(values[i]);
    }
  }

  void _remove(List<V> values) {
    if (_removeValue == null) {
      return;
    }
    for (int i = values.length - 1; i >= 0; --i) {
      _removeValue(values[i]);
    }
  }

  void _clear(List<V> values) {
    if (values.isEmpty) {
      return;
    }
    if (_clearValues != null) {
      _clearValues(values);
    } else {
      _remove(values);
    }
  }
}