part of insync;

class AbstractListReverser<V> extends Owner {
  AbstractList<V> _source;
  AbstractList<V> get source => _source;

  AbstractList<V> _target;
  AbstractList<V> get target => _target;

  AbstractListReverser(this._source, {AbstractList<V> target}) {
    assert(_source != null);
    _target = (target != null) ? target : _source.createEmpty()..ownBy(this);
    _target.tryAddAll(_source.list.reversed.toList(growable: false));
  }

  void destroy() {
    _target.tryClear();
    super.destroy();
  }
}