part of insync;

class AbstractMapMapper<K, S, T> extends
AbstractCollectionMapper<S, T, AbstractMap<K, S>, AbstractMap<K, T>> {

  AbstractMapMapper(AbstractMap<K, S> source,
      {AbstractMap<K, T> target, T create(S data), void destroy(T item, S data)}) :
      super(source, target: target, create: create, destroy: destroy) {
    _target.trySetAll(_create(_source.base));
  }

  void destroy() {
    _destroy(_target.removeAll(_source.getKeys()), _source.base);
    super.destroy();
  }

  Map<K, T> _create(Map<K, S> datas) {
    Map<K, T> items = new HashMap<K, T>();
    for (K key in datas.keys) {
      assert(!_target.containsKey(key));
      items[key] = _createItem(datas[key]);
    }
    return items;
  }

  void _destroy(Map<K, T> items, Map<K, S> datas) {
    if (_destroyItem == null) {
      return;
    }
    for (K key in items.keys) {
      _destroyItem(items[key], datas[key]);
    }
  }
}