part of insync;

class ObservableListHeaper<V> extends AbstractListHeaper<V> {
  ObservableListHeaper(ObservableList<V> source, {AbstractSet<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReplace.listen(_onReplace));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(ObservableListSpliceEventParams<V> params) {
    ListSpliceResult<V> spliceResult = params.spliceResult;
    _target.trySplice(spliceResult.removedValues, spliceResult.addedValues);
  }

  void _onReplace(ObservableListReplaceEventParams<V> params) {
    _target.trySplice([params.oldValue], [params.newValue]);
  }

  void _onClear(List<V> values) {
    _target.tryRemoveAll(values);
  }
}