part of insync;

class ObservableListIndexer<K, V> extends AbstractListIndexer<K, V> {
  ObservableListIndexer(ObservableList<V> source, {AbstractMap<K, V> target, K getKey(V value)}) :
    super(source, target: target, getKey: getKey) {
    own(source.onSplice.listen(_onSplice));
    own(source.onReplace.listen(_onReplace));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(ObservableListSpliceEventParams<V> params) {
    ListSpliceResult<V> spliceResult = params.spliceResult;
    _target.trySplice(
        _keys(spliceResult.removedValues),
        _index(spliceResult.addedValues));
  }

  void _onReplace(ObservableListReplaceEventParams<V> params) {
    _target.trySplice(
        _keys([params.oldValue]),
        _index([params.newValue]));
  }

  void _onClear(List<V> values) {
    _target.tryRemoveAll(_keys(values));
  }
}