part of insync;

class ObservableMapHeaper<K, V> extends AbstractMapHeaper<K, V> {
  ObservableMapHeaper(ObservableMap<K, V> source, {AbstractSet<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _target.trySplice(
        spliceResult.removedValues.values.toList(growable: false),
        spliceResult.addedValues.values.toList(growable: false));
  }

  void _onClear(Map<K, V> values) {
    _target.tryRemoveAll(values.values.toList(growable: false));
  }
}