part of insync;

class ObservableMapIndexer<SK, TK, V> extends AbstractMapIndexer<SK, TK, V> {
  ObservableMapIndexer(ObservableMap<SK, V> source, {AbstractMap<TK, V> target,
    TK getKey(V value)}) : super(source, target: target, getKey: getKey) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<SK, V> spliceResult) {
    _target.trySplice(
        _keys(spliceResult.removedValues.values.toList(growable: false)),
        _index(spliceResult.addedValues.values.toList(growable: false)));
  }

  void _onClear(Map<SK, V> values) {
    _target.tryRemoveAll(_keys(values.values.toList(growable: false)));
  }
}