part of insync;

class ObservableMapObserver<K, V> extends AbstractMapObserver<K, V> {
  ObservableMapObserver(ObservableMap<K, V> source, {void add(V value), void remove(V value),
    void clear(List<V> values), void change()}) : super(source, add: add, remove: remove,
        clear: clear, change: change) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
    if (_change != null) {
      own(source.onChange.listen((p) { _change(); }));
    }
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _remove(spliceResult.removedValues.values.toList(growable: false));
    _add(spliceResult.addedValues.values.toList(growable: false));
  }

  void _onClear(Map<K, V> values) {
    _clear(values.values.toList(growable: false));
  }
}