part of insync;

class ObservableMapOrderer<K, V> extends AbstractMapOrderer<K, V> {
  ObservableMapOrderer(ObservableMap<K, V> source, {AbstractList<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(MapSpliceResult<K, V> spliceResult) {
    _splice(
        spliceResult.removedValues.values.toSet(),
        spliceResult.addedValues.values.toSet());
  }

  void _onClear(Map<K, V> values) {
    _target.removeValues(values.values.toList(growable: false));
  }
}