part of insync;

class ObservableSetFilterer<V> extends AbstractSetFilterer<V> {
  ObservableSetFilterer(ObservableSet<V> source, {AbstractSet<V> target, bool filter(V value)}) :
    super(source, target: target, filter: filter) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _target.trySplice(
        spliceResult.removedValues,
        spliceResult.addedValues.where(_filterValue).toList(growable: false));
  }

  void _onClear(List<V> values) {
    _target.tryRemoveAll(values);
  }
}