part of insync;

class ObservableSetIndexer<K, V> extends AbstractSetIndexer<K, V> {
  ObservableSetIndexer(ObservableSet<V> source, {AbstractMap<K, V> target, K getKey(V value)}) :
    super(source, target: target, getKey: getKey) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _target.trySplice(
        _keys(spliceResult.removedValues),
        _index(spliceResult.addedValues));
  }

  void _onClear(List<V> values) {
    _target.tryRemoveAll(_keys(values));
  }
}