part of insync;

class ObservableSetMapper<S, T> extends AbstractSetMapper<S, T> {
  ObservableSetMapper(ObservableSet<S> source,
      {AbstractSet<T> target, T create(S data), void destroy(T item, S data)}) :
      super(source, target: target, create: create, destroy: destroy) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<S> sourceResult) {
    List<S> removedDatas = sourceResult.removedValues;
    List<S> addedDatas = sourceResult.addedValues;
    _target.trySplice(_get(removedDatas), _create(addedDatas));
    _destroy(removedDatas);
  }

  void _onClear(List<S> datas) {
    _target.tryRemoveAll(_get(datas));
    _destroy(datas);
  }
}