part of insync;

class ObservableSetOrderer<V> extends AbstractSetOrderer<V> {
  ObservableSetOrderer(ObservableSet<V> source, {AbstractList<V> target}) :
    super(source, target: target) {
    own(source.onSplice.listen(_onSplice));
    own(source.onClear.listen(_onClear));
  }

  void _onSplice(SetSpliceResult<V> spliceResult) {
    _splice(
        spliceResult.removedValues.toSet(),
        spliceResult.addedValues.toSet());
  }

  void _onClear(List<V> values) {
    _target.removeValues(values);
  }
}