part of insync;

class WrapIterable<E> implements Iterable<E> {
  Iterable<E> _iterableBase;

  Iterable<E> get base => _iterableBase;

  WrapIterable(this._iterableBase) {}

  Iterator<E> get iterator => base.iterator;
  Iterable map(f(E element)) => base.map(f);
  Iterable<E> where(bool test(E element)) => base.where(test);
  Iterable expand(Iterable f(E element)) => base.expand(f);
  bool contains(E element) => base.contains(element);
  void forEach(void f(E element)) => base.forEach(f);
  E reduce(E combine(E value, E element)) => base.reduce(combine);
  dynamic fold(var initialValue, dynamic combine(var previousValue, E element)) =>
      base.fold(initialValue, combine);
  bool every(bool test(E element)) => base.every(test);
  String join([String separator = ""]) => base.join(separator);
  bool any(bool test(E element)) => base.any(test);
  List<E> toList({ bool growable: true }) => base.toList(growable: growable);
  Set<E> toSet() => base.toSet();
  int get length => base.length;
  bool get isEmpty => base.isEmpty;
  bool get isNotEmpty => base.isNotEmpty;
  Iterable<E> take(int n) => base.take(n);
  Iterable<E> takeWhile(bool test(E value)) => base.takeWhile(test);
  Iterable<E> skip(int n) => base.skip(n);
  Iterable<E> skipWhile(bool test(E value)) => base.skipWhile(test);
  E get first => base.first;
  E get last => base.last;
  E get single => base.single;
  E firstWhere(bool test(E element), { E orElse() }) => base.firstWhere(test, orElse: orElse);
  E lastWhere(bool test(E element), {E orElse()}) => base.lastWhere(test, orElse: orElse);
  E singleWhere(bool test(E element)) => base.singleWhere(test);
  E elementAt(int index) => base.elementAt(index);
}