part of insync;

class WrapList<E> implements List<E> {
  List<E> _list;

  WrapList(this._list) {}

  WrapList.empty() : _list = new List<E>() {}

  Iterator<E> get iterator => _list.iterator;
  Iterable<E> where(bool test(E element)) => _list.where(test);
  Iterable expand(Iterable f(E element)) => _list.expand(f);
  bool contains(E element) => _list.contains(element);
  void forEach(void f(E element)) => _list.forEach(f);
  E reduce(E combine(E value, E element)) => _list.reduce(combine);
  dynamic fold(var initialValue,
               dynamic combine(var previousValue, E element)) => _list.fold(initialValue, combine);
  bool every(bool test(E element)) => _list.every(test);
  String join([String separator = ""]) => _list.join(separator);
  bool any(bool test(E element)) => _list.any(test);
  List<E> toList({ bool growable: true }) => _list.toList(growable: growable);
  Set<E> toSet() => _list.toSet();
  int get length => _list.length;
  bool get isEmpty => _list.isEmpty;
  bool get isNotEmpty => _list.isNotEmpty;
  Iterable<E> take(int n) => _list.take(n);
  Iterable<E> takeWhile(bool test(E value)) => _list.takeWhile(test);
  Iterable<E> skip(int n) => _list.skip(n);
  Iterable<E> skipWhile(bool test(E value)) => _list.skipWhile(test);
  E get first => _list.first;
  E get last => _list.last;
  E get single => _list.single;
  E firstWhere(bool test(E element), { E orElse() }) => _list.firstWhere(test, orElse: orElse);
  E lastWhere(bool test(E element), {E orElse()}) => _list.lastWhere(test, orElse: orElse);
  E singleWhere(bool test(E element)) => _list.singleWhere(test);
  E elementAt(int index) => _list.elementAt(index);
  E operator [](int index) => _list[index];
  Iterable<E> get reversed => _list.reversed;
  int indexOf(E element, [int start = 0]) => _list.indexOf(element, start);
  int lastIndexOf(E element, [int start]) => _list.lastIndexOf(element, start);
  List<E> sublist(int start, [int end]) => _list.sublist(start, end);
  Iterable<E> getRange(int start, int end) => _list.getRange(start, end);
  Map<int, E> asMap() => _list.asMap();

  Iterable map(f(E element)) => _list.map(f);
  void operator []=(int index, E value) { _list[index] = value; }
  void set length(int newLength) { _list.length = newLength; }
  void add(E value) => _list.add(value);
  void addAll(Iterable<E> iterable) => _list.addAll(iterable);
  void sort([int compare(E a, E b)]) => _list.sort(compare);
  void shuffle([Random random]) => _list.shuffle(random);
  void clear() => _list.clear();
  void insert(int index, E element) => _list.insert(index, element);
  void insertAll(int index, Iterable<E> iterable) => _list.insertAll(index, iterable);
  void setAll(int index, Iterable<E> iterable) => _list.setAll(index, iterable);
  bool remove(Object value) => _list.remove(value);
  E removeAt(int index) => _list.removeAt(index);
  E removeLast() => _list.removeLast();
  void removeWhere(bool test(E element)) => _list.removeWhere(test);
  void retainWhere(bool test(E element)) => _list.retainWhere(test);
  void setRange(int start, int end, Iterable<E> iterable, [int skipCount = 0]) =>
      _list.setRange(start, end, iterable);
  void removeRange(int start, int end) => _list.removeRange(start, end);
  void fillRange(int start, int end, [E fillValue]) => _list.fillRange(start, end, fillValue);
  void replaceRange(int start, int end, Iterable<E> iterable) => _list.replaceRange(start, end, iterable);
}