part of insync;

class ComponentList extends Destroyable {
  Component _parent;
  AbstractList<Component> source;
  AbstractListMapper<Component, Component> _mapper;
  ComponentInserter _inserter;

  ComponentList(this._parent, this.source, Element el) {
    _parent._lists.add(this);
    _mapper = source.createMapper(
        create: (Component child) {
          _parent._initChild(child);
          return child;
        },
        destroy: (Component child, Component childAsWell) {
          _parent._doneChild(child);
        }
    );
    _inserter = new ComponentInserter(_mapper.target, el);
  }

  void destroy() {
    _inserter.destroy();
    _mapper.destroy();
    _parent._lists.remove(this);
    super.destroy();
  }
}