part of insync;

class RadioUpdater extends Destroyable {
  final Element el;
  final String name;
  final Property<String> property;

  String _selector;
  EventAttachment _attachment;

  RadioUpdater(this.el, this.name, this.property) {
    _selector = 'input[type=radio][name="' + name + '"]';
    _update();
    _attachment = property.onChange.listen(_update);
  }

  void destroy() {
    _attachment.destroy();
    super.destroy();
  }

  void _update([p]) {
    String value = property.value;
    if (value != null) {
      InputElement radioEl = el.querySelector(_selector + '[value="' + value + '"]');
      if (radioEl != null) {
        radioEl.checked = true;
        return;
      }
    }
    InputElement radioEl = el.querySelector(_selector + ':checked');
    if (radioEl != null) {
      radioEl.checked = false;
    }
  }
}