part of insync;

class Template {
  String _html;
  Element _mirror;
  List<String> _prefixes;
  Map<String, List<int>> _els;

  Template.html(this._html);

  TemplateOutput createElement() {
    _compile();
    Element root = _mirror.clone(true);
    Map<String, Element> els = new Map<String, Element>();
    for (String id in _els.keys) {
      List<int> path = _els[id];
      Element el = root;
      for (int index in path) {
        el = el.children[index];
      }
      els[id] = el;
    }
    return new TemplateOutput(root, els);
  }

  void _compile() {
    if (_mirror != null) {
      return;
    }
    _mirror = new Element.html(_html, treeSanitizer: new _NullTreeSanitizer());
    _prefixes = StringUtil.getWords(_mirror.attributes.remove('prefix'));
    _mirror.classes.addAll(_prefixes);
    _els = new Map<String, List<int>>();
    List<int> path = [];
    _walk(_mirror, path, (Element el, List<int> path) {
      List<String> ids = StringUtil.getWords(el.attributes['id']);
      for (String id in ids) {
        for (String prefix in _prefixes) {
          el.classes.add(prefix + '-' + id);
        }
        if (!_els.containsKey(id)) {
          _els[id] = path.toList();
        }
      }
      new MapUtil<String, String>().setOrRemove(el.attributes, 'id', el.attributes.remove('gid'));
    });
    _els['root'] = [];
  }

  void _walk(Element el, List<int> path, void callback(Element el, List<int> path)) {
    callback(el, path);
    int index = path.length;
    path.add(0);
    List<Element> children = el.children.toList();
    for (int i = 0, l = children.length; i < l; ++i) {
      path[index] = i;
      _walk(children[i], path, callback);
    }
    path.removeLast();
  }
}